# Class SynchronousTransportListener

TransportAdapter
org.apache.jmeter.protocol.smtp.sampler.protocol.SynchronousTransportListener

public class SynchronousTransportListener extends TransportAdapter
This class implements a listener for SMTP events and a monitor for all threads sending mail. The main purpose is to synchronize the send action with the end of communication with remote smtp server, so that sending time can be measured.

## Constructor Summary

Constructors
Constructor
Description
`SynchronousTransportListener()`
Creates a new instance of SynchronousTransportListener

## Method Summary

Modifier and Type
Method
Description
`void`
`attend()`
Synchronized-method
`void`
`finish()`
Synchronized-method
`void`
`messageDelivered(TransportEvent e)`
`void`
`messageNotDelivered(TransportEvent e)`
`void`
`messagePartiallyDelivered(TransportEvent e)`

## Constructor Details

### SynchronousTransportListener

public SynchronousTransportListener()
Creates a new instance of SynchronousTransportListener

## Method Details

### messageDelivered

public void messageDelivered(TransportEvent e)

### messageNotDelivered

public void messageNotDelivered(TransportEvent e)

### messagePartiallyDelivered

public void messagePartiallyDelivered(TransportEvent e)

### attend

public void attend() throws InterruptedException
Synchronized-method

Waits until `finish()` was called and thus the end of the mail sending was signalled.

Throws:
  `InterruptedException` - when interrupted while waiting with the lock

### finish

public void finish()
Synchronized-method